﻿package vfl.as3.roteiro
{
	import flash.events.EventDispatcher;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import vfl.as3.util.StringUtils;
	import flash.utils.Timer;
	import flash.utils.setTimeout;
	import flash.utils.clearTimeout;
	import flash.utils.getTimer;
	
	import gs.TweenLite;
	
	import flash.filters.DropShadowFilter;
	
	public class Legenda extends EventDispatcher
	{
		// Intervalo em milisegundos de exibição entre as
		// letras de uma frase.
		static const TEMPO_LEGENDA    	= 70; // Influencia no tempo que a legenda permance visivel.
		static const TEMPO_BOCA 		= 60; // Influencia no tempo que o personagem move boca.
		static const TEMPO_MINIMO 		= 3000;
		
		// Componente de exibição do texto.
		public var texto 		= "";
		public var alinhamento  = "";
		public var alvo  		= null;
		public var alturaInicialAlvo = 0;
		public var caixaTexto 	= null;
		public var cor			= "";
		public var textFormat 	= null;
		
		// Controle de tempo de movimentação da boca.
		public var timer			= null;
		public var tempoBoca 		= 0;
		public var tempoBocaInicial	= 0;
		
		// Palavras-chave.
		public var palavrasChave  	= null;
		public var destaque			= null;
		//public var removerDestaqueToi = 0;
		
		// Paginacao do texto.
		public var blocos			= null;
		public var bloco			= 0;
		
		public var tempo			= 0;
		
		// Timeouts.
		public var exibicaoToi 		= -1;
		public var blocoToi 		= -1;		
		
		public const TAM_BLOCO		= 105;
		public const MIN_TAM_BLOCO  = 20;
		
		public function Legenda(pTexto	: String, 
								pAlvo	: DisplayObject, 
								pCor	: uint = 0xFFFFFF, 
								pAlinhamento = "CB")
		{	
			texto		= pTexto;
			alvo  		= pAlvo;
			alturaInicialAlvo = alvo.height;
 			alinhamento = pAlinhamento;
			cor 		= pCor;
			
			textFormat  		= new TextFormat();
			textFormat.color 	= cor;
			textFormat.size  	= 20;
			textFormat.font  	= "Arial";
			textFormat.letterSpacing = 1;
			textFormat.align 	= "center";
			
			CriarBlocos();
			CriarCaixaTexto();			
		}
		
		public function CriarBlocos()
		{
			blocos = texto.split('|');
		}
		
		public function SetTextFormat(pTextFormat: TextFormat)
		{
			textFormat = pTextFormat;
		}
		
		public function CriarCaixaTexto()
		{
			caixaTexto = new TextField();
			caixaTexto.width = 650;
			caixaTexto.height= 70;
			caixaTexto.x = 25;
			caixaTexto.defaultTextFormat = textFormat;
			caixaTexto.multiline = true;
			caixaTexto.wordWrap  = true;
			caixaTexto.selectable= false;
			caixaTexto.autoSize = TextFieldAutoSize.CENTER;

			var filtro:DropShadowFilter = new DropShadowFilter();
			filtro.distance = 0;
			filtro.blurX = 2;
			filtro.blurY = 2;
			filtro.color = 0x000000;
			filtro.strength = 3;
			
			caixaTexto.filters = [filtro];
			caixaTexto.alpha = 0;
			
			destaque			= new MovieClip();			
			destaque.filters 	= [filtro];
			
			alvo.addChild(caixaTexto);
			alvo.addChild(destaque);
		}
		
		public function Exibir()
		{
			bloco 				= 0;				
			caixaTexto.text 	= blocos[0];
			
			PosicionarCaixaTexto();
			
			TweenLite.to(caixaTexto, 0.15, {alpha: 1, onComplete: FimInicioExibicao});
			dispatchEvent(new LegendaEvento(LegendaEvento.INICIO));

		}
		
		private function PosicionarCaixaTexto()
		{
			caixaTexto.height	= caixaTexto.textHeight + 10;
			caixaTexto.y 		= alturaInicialAlvo/2 - caixaTexto.textHeight/2;
		}
		
		public function FimInicioExibicao()
		{						
			// Tempo que a legenda permanece visivel.
			if (tempo == 0)
			{
				tempo =  TEMPO_LEGENDA * texto.length;
				tempo     = ( tempo > TEMPO_MINIMO ? tempo : TEMPO_MINIMO);
			}
			exibicaoToi = setTimeout(FimExibicao, tempo);
						
			if (blocos.length > 1) blocoToi = setTimeout(ProximoBloco, TEMPO_LEGENDA * blocos[0].length);
			else blocoToi = -1;
		}
		
		public function SetTempoTotal(pTempo)
		{
			tempo = pTempo;
		}
		
		public function ProximoBloco()
		{
			bloco++;
			if (bloco < blocos.length)
			{
				RemoverDestaque();				
				caixaTexto.text 	= blocos[bloco];
				
				PosicionarCaixaTexto();
				
				blocoToi =  setTimeout(ProximoBloco, TEMPO_LEGENDA * blocos[bloco].length);
			}
			else blocoToi = -1;
		}
				
		public function FimExibicao()
		{
			exibicaoToi = -1;
			RemoverDestaque();
			TweenLite.to(caixaTexto, 0.2, {alpha: 0, onComplete: FimExibicao2});
		}
		
		public function FimExibicao2()
		{
			dispatchEvent(new LegendaEvento(LegendaEvento.FIM));
		}
		
		public function Encerrar()
		{
			if (exibicaoToi != -1) 	clearTimeout(exibicaoToi);
			if (blocoToi != -1) 	clearTimeout(blocoToi);
			
			RemoverDestaque();
			alvo.removeChild(caixaTexto);
		}
		
		public function DestacarPalavra(inicio, fim, cor = "0xFFFFFF")
		{
			RemoverDestaque();
			trace( inicio + "," + fim);
			
			var ind;
			var lineMetrics;
			var margin;
		
			inicio  = ConverterParaPosicaoBloco(inicio);
			fim		= ConverterParaPosicaoBloco(fim);
			trace(inicio.bloco + " - " + inicio.posicao + "," +fim.posicao);
			
			var rectInicio 	= caixaTexto.getCharBoundaries(inicio.posicao);
			var rectFim 	= caixaTexto.getCharBoundaries(fim.posicao);
			
			if (rectInicio.y != rectFim.y) 
			{
				ind 		= caixaTexto.getLineIndexOfChar(inicio.posicao);
				lineMetrics = caixaTexto.getLineMetrics(ind);
				margin		= (caixaTexto.width- lineMetrics.width)/2;
				rectFim.x = margin + lineMetrics.width;
			}
			
			destaque.graphics.clear();
			destaque.graphics.lineStyle(2, cor);
			destaque.graphics.moveTo(rectInicio.x-2			  , rectInicio.y + rectInicio.height);
			destaque.graphics.lineTo(rectFim.x + rectFim.width, rectInicio.y + rectInicio.height);			

			if (rectInicio.y != rectFim.y) 
			{
				ind 		= caixaTexto.getLineIndexOfChar(fim.posicao);
				lineMetrics = caixaTexto.getLineMetrics(ind);
				margin		= (caixaTexto.width- lineMetrics.width)/2;
				rectInicio.x = margin;
				rectFim 	 = caixaTexto.getCharBoundaries(fim.posicao);	
				
				destaque.graphics.moveTo(rectInicio.x-2			  , rectFim.y + rectFim.height);
				destaque.graphics.lineTo(rectFim.x + rectFim.width, rectFim.y + rectFim.height);							
			}
			
			/*
			destaque.graphics.drawRect(rectInicio.x-3, rectInicio.y + rectInicio.height, 
									   rectFim.x - rectInicio.x + rectFim.width + 3, 1);
									   */
									   
			destaque.x = caixaTexto.x;
			destaque.y = caixaTexto.y;
			
			//removerDestaqueToi = setTimeout(RemoverDestaque, 1000);
			
			//trace("aaa " + inicio + " " + fim);
			caixaTexto.setSelection(inicio, fim);
		}
			
		public function RemoverDestaque()
		{
			destaque.graphics.clear();
			while (destaque.numChildren > 0) destaque.removeChildAt(0);
		}
		
		public function ConverterParaPosicaoBloco(posicao)
		{
			if (posicao <  blocos[0].length) return {bloco: 0, posicao: posicao};
			
			var contador = 0;
			var i 		 = 0;
			while (posicao > contador)
			{
				contador += blocos[i].length;
				i++;
			}
			i--;
			
			var inicioBloco = contador - blocos[i].length;
			return {bloco: i, posicao: posicao-inicioBloco};
		}
	}
}