﻿package vfl.as3.ui
{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.EventDispatcher;
	
	/********
	*	Representa um componente de interface RadioBox.
	*	O movieclip que representará graficamente o componente deverá ter duas frames:
	*	a primeira representa o componente NÃO selecionado, e a segunda o componente selecionado.
	***********/
	public class Radio extends EventDispatcher
	{
		public var data				: Array;
		public var selectedIndex	: int;
		
		/***********
		*	pData é um array de objetos, onde cada objeto assume o formato:
		*		{movieClip: movieClip_mc, value: 0}
		*
		*	Ex: [{movieClip: radio1_mc, value: 0}, {movieClip: radio2_mc, value: 1}, {movieClip: radio2_mc, value: 2}]  
		*
		*****************/
		public function Radio( pData	: Array )
		{	
			data 	 		= pData;
			selectedIndex	= 0;
			
			// Cria os eventlisteners.
			for ( var i = 0; i < data.length; i++ )
			{
				data[i].movieClip.mouseChildren = false;
				data[i].movieClip.buttonMode 	= true;
				data[i].movieClip.i				= i;
				data[i].movieClip.addEventListener( MouseEvent.CLICK, RadioClick );
			}
			
			Update();
		}
		
		public function RadioClick( evt )
		{
			var movieClip = MovieClip( evt.target );
			selectedIndex = movieClip.i;
			
			Update();
		}
		
		public function SetSelectedByIndex( pIndex )
		{
			selectedIndex 	= pIndex;
			
			Update();
		}
		
		public function SetSelectedByValue( pValue )
		{
			for ( var i = 0; i < data.length; i++ )
			{
				if ( data[i].value == pValue )
				{
					selectedIndex 	= i;
					Update();
					return ;
				}
			}
		}
		
		public function GetSelectedIndex()
		{
			return selectedIndex;
		}
		
		public function GetSelectedValue()
		{
			return data[selectedIndex].value;
		}
		
		public function Update()
		{
			for ( var i = 0; i < data.length; i++ )
			{
				data[i].movieClip.gotoAndStop( 1 );
			}
			
			data[selectedIndex].movieClip.gotoAndStop( 2 );
			
			dispatchEvent( new RadioEvent( RadioEvent.CHANGE, selectedIndex, data[selectedIndex].value ) );
		}
			
		public function Dispose()
		{
			// Remove os eventlisteners.
			for ( var i = 0; i < data.length; i++ )
			{
				data[i].movieClip.mouseChildren = true;
				data[i].movieClip.buttonMode 	= false;
				data[i].movieClip.removeEventListener( MouseEvent.CLICK, RadioClick );
			}
		}
	}
}