﻿package vfl.as3.ui
{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.EventDispatcher;
	
	public class SlideBar extends EventDispatcher
	{
		public var bar_mc	: MovieClip;
		public var maxD	: int;
		public var segments	: int;
		public var segmentSize = 0;
		public var selectedSegment_ = -1;
		public var percent_ = 0;

		public var root_mc	: Stage;
		public var parent_mc: MovieClip;

		public var type		: int;
		public var startPos	: int;
		
		public static var TYPE_HORIZONTAL = 0;
		public static var TYPE_VERTICAL	  = 1;		

		public function SlideBar( pBar_mc	: MovieClip,
								  pMaxD		: int,								 
								  pSegments	: int = 0,
								  pType 	: int = 0 )
		{	
			bar_mc 	 = pBar_mc;
			maxD  	 = pMaxD;
			segments = pSegments;
			type	 = pType;
			
			if ( type == TYPE_HORIZONTAL )	startPos = pBar_mc.x;
			else							
			{
				startPos = pBar_mc.y;
				startPos = startPos - maxD;
			}
			
			if ( segments > 0 ) segmentSize = maxD / segments;
		
			var mc 		= bar_mc.parent;
			parent_mc 	= mc;
			
			while (!(mc is Stage))	mc = mc.parent;			
			root_mc = mc;
			
			bar_mc.buttonMode = true;
			bar_mc.addEventListener(MouseEvent.MOUSE_DOWN , StartDrag);
			root_mc.addEventListener(MouseEvent.MOUSE_UP  , StopDrag);
		}
		
		public function StartDrag(evt)
		{
			root_mc.addEventListener(MouseEvent.MOUSE_MOVE, Drag);
		}
		
		public function StopDrag(evt)
		{
			root_mc.removeEventListener(MouseEvent.MOUSE_MOVE, Drag);
		}
		
		// DEPRECIADO!
		public function SetStartPos(pSart: int)
		{
			trace("[SlideBar.as] ATENÇÃO: O método SetStartPos está DEPRECIADO. Utilize 'slideBar.percent = 0.5;' ou 'slideBar.segment= 3;'");
			startPos = pSart;
		}
		
		public function Drag(evt)
		{
			var seg 	= -1;			
			var pos 	= type == TYPE_HORIZONTAL ? parent_mc.mouseX : parent_mc.mouseY;
			var prop	= type == TYPE_HORIZONTAL ? "x" : "y";
			
			if (pos > startPos && pos < startPos + maxD)
			{
				if (segments == 0)  bar_mc[prop] = pos;
				else
				{
					var mouseBase 	= pos - startPos;
					seg 			= Math.round(mouseBase / segmentSize);
					
					bar_mc[prop] 	= startPos + selectedSegment_*segmentSize;
				}
			}
			else
			{
				if (pos <= startPos) 
				{
					bar_mc[prop] 	= startPos;
					seg 			= 0;
				}
				else 
				{
					bar_mc[prop]	= startPos + maxD;
					seg 			= segments;
				}
			}
			
			percent_ = (bar_mc[prop] - startPos) / maxD;	
			if (type == TYPE_VERTICAL) percent_ = 1 - percent_;
			
			if (seg != -1 && segments != 0)
			{
				if (selectedSegment_ != seg)
				{
					selectedSegment_ 	= seg;
					percent_ 			= selectedSegment_ / segments;					
					dispatchEvent(new SlideBarEvent(SlideBarEvent.CHANGE, percent_, ( type == TYPE_HORIZONTAL ? selectedSegment_ : segments - selectedSegment_), bar_mc ) );
				}
			}
			else
			{
				dispatchEvent(new SlideBarEvent( SlideBarEvent.CHANGE, percent_, selectedSegment_, bar_mc ));
			}
		}		
				
		public function updateCursor(bySegment)
		{
			var prop	= type == TYPE_HORIZONTAL ? "x" : "y";
			
			if (bySegment) percent_	 = (selectedSegment_ / segments)
			bar_mc[prop] = (percent_ * maxD) + startPos;
		}
		
		//----------------------------------------------------------------
		public function set selectedSegment(s)
		{
			selectedSegment_ = s;
			updateCursor(true);
			dispatchEvent(new SlideBarEvent( SlideBarEvent.CHANGE, percent_, selectedSegment_, bar_mc ));
		}
		
		public function get selectedSegment()
		{
			return selectedSegment_;
		}
		
		public function get percent()
		{
			var prop	= type == TYPE_HORIZONTAL ? "x" : "y";
			percent_ = (bar_mc[prop] - startPos) / maxD;	
			
			return percent_;
		}
		
		public function set percent(p)
		{
			percent_ = p;
			updateCursor(false);
			dispatchEvent(new SlideBarEvent( SlideBarEvent.CHANGE, percent_, selectedSegment_, bar_mc ));
		}
		
		//---------------------------------------------------------------
		public function Reset()
		{
			var prop	= type == TYPE_HORIZONTAL ? "x" : "y";
			bar_mc[prop]= startPos;
		}
		
		public function Dispose()
		{
			bar_mc.removeEventListener(MouseEvent.MOUSE_DOWN	, StartDrag);
			root_mc.removeEventListener(MouseEvent.MOUSE_UP 	, StopDrag);
			root_mc.removeEventListener(MouseEvent.MOUSE_MOVE	, Drag);		
		}		
		
	}
}