﻿/*
Collision detection by Frederik Humblet
(c) Boulevart N.V.
http://labs.boulevart.be

Port from the AS2 version by Grant Skinner
http://www.gskinner.com/blog/archives/2005/08/flash_8_shape_b.html
*/
package vfl.as3.util
{	
	import flash.geom.Point;
	public class StageUtil
	{
		public static const POINT_LEFT	= "left";
		public static const POINT_CENTER = "center";
		public static const POINT_RIGHT	= "right";
		
		public static const POINT_TOP	= "top";
		public static const POINT_MIDDLE = "middle";
		public static const POINT_BOTTOM = "bottom";
		
		public static function FillToStage(displayObject, keepPropotions = true)
		{
			var newWidth, newHeight;
			if (keepPropotions)
			{
				if (displayObject.width == 0 || displayObject.height == 0) return;
				var rel 		= displayObject.width / displayObject.height;
				newWidth	= displayObject.stage.stageWidth;
				newHeight   = newWidth / rel;
				
				if (newHeight < displayObject.stage.stageHeight)
				{
					rel 		= displayObject.height / displayObject.width;
					newHeight 	= displayObject.stage.stageHeight;
					newWidth	= newHeight / rel; 
				}
			}
			else
			{
				newWidth	= displayObject.stage.stageWidth;
				newHeight	= displayObject.stage.stageHeight;
			}
			
			displayObject.width = newWidth;
			displayObject.height= newHeight;
		}
		
		public static function GetPoint(displayObject, hPos, vPos)
		{
			var rect = displayObject.getBounds(displayObject.parent);
			var point= new Point(displayObject.x, displayObject.y);
			
			switch(hPos)
			{
				case POINT_LEFT:	point.x = rect.x;	break;
				case POINT_CENTER:	point.x = rect.x + (rect.width/2);	break;
				case POINT_RIGHT:	point.x = rect.x + rect.width;		break;
			}
			
			switch(vPos)
			{
				case POINT_TOP:		point.y = rect.y;	break;
				case POINT_MIDDLE:	point.y = rect.y + (rect.height/2);	break;
				case POINT_BOTTOM:	point.y = rect.y + rect.height; 	break;
			}
			
			return point;
			
		}
	}
}